<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: VizBlocks Framework</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">VizBlocks Framework </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><a class="anchor" id="md_README"></a>This is an Arduino library that lets you easily create nodes to stick on the wall. Each node will listen on an MQTT channel, and respond to commands. So a node with a servo motor in might respond to:</p><ul>
<li><code>Wiggle 30</code> - wiggle by 30 degrees a few times</li>
<li><code>GoTo 20</code> - move to 20 degrees These commands can be put in via NodeRED, or through the USB Serial connection for testing. There is a growing library of <code><a class="el" href="class_behaviour.html" title="Parent class for all other behaviours.">Behaviour</a></code>s that represent the different things the node might do.</li>
</ul>
<p><a href="https://git.ecdf.ed.ac.uk/design-informatics/vizblocks/vizblocksframework">Find the project on GitLab here.</a></p>
<h1><a class="anchor" id="autotoc_md1"></a>
Installation</h1>
<p>One way to install this is put it in you personal Arduino libraries directory. On a mac, this is <code>~/Documents/Arduino/libraries</code>. It is best to check it out with a capitalised name, i.e. <code>VizBlocksFramework</code> not <code>vizblocksframework</code>. To do this, you can use:</p>
<div class="fragment"><div class="line">git clone https://git.ecdf.ed.ac.uk/design-informatics/vizblocks/vizblocksframework.git VizBlocksFramework</div>
</div><!-- fragment --><p>The library will then appear in your list of Arduino libraries, along with examples.</p>
<h1><a class="anchor" id="autotoc_md2"></a>
Dependencies</h1>
<p>This library depends on:</p><ul>
<li>Adafruit_MQTT</li>
<li>Servo</li>
<li>(one of the neopixel libraries once this is integrated)</li>
<li>ESP8266WiFi (which should be present by magic if you're using the D1 Mini)</li>
</ul>
<h1><a class="anchor" id="autotoc_md3"></a>
Development</h1>
<p>Because this is not a single sketch, development needs a bit of thinking about. It is probably easier to use another IDE - Atom is good! You will also have to keep pushing/pulling changes to make sure you have the latest version.</p>
<h1><a class="anchor" id="autotoc_md4"></a>
Usage</h1>
<p>The library is designed to be used within normal Arduino sketches. It wraps up most of the business of connecting to MQTT etc. in a <code><a class="el" href="class_viz_block.html" title="The main VizBlock class.">VizBlock</a></code> class, and you then give it a bunch of <code><a class="el" href="class_behaviour.html" title="Parent class for all other behaviours.">Behaviour</a></code>s that do interesting things.</p>
<h2><a class="anchor" id="autotoc_md5"></a>
Setup</h2>
<p>The node is set up with all of the connection information for the WiFi network and for Node-RED, e.g.:</p>
<div class="fragment"><div class="line">#include &lt;VizBlocks.h&gt;</div>
<div class="line"> </div>
<div class="line">VizBlocks node(</div>
<div class="line">  &quot;new001&quot;,     // Our ID</div>
<div class="line">  &quot;VizBlocksNet&quot;, //Wifi Access Point</div>
<div class="line">  &quot;VizBlocksAP&quot;,  //WiFi Password</div>
<div class="line">  &quot;192.168.4.1&quot;,//IP address of Node RED server</div>
<div class="line">  1883          //Port for Node RED server</div>
<div class="line">  &quot;&quot;,  //MQTT username</div>
<div class="line">  &quot;&quot;,    //MQTT password</div>
<div class="line">  &quot;&quot; // SHA1 fingerprint (for mqtt server using SSL/TLS)</div>
<div class="line">  );</div>
</div><!-- fragment --><p>A very simple sketch would then simply initialise this, and call its main function in a loop:</p>
<div class="fragment"><div class="line">void setup()</div>
<div class="line">{</div>
<div class="line">  Serial.begin(115200);</div>
<div class="line">  //Initialise the whole infrastructure</div>
<div class="line">  node.init();</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line">void loop()</div>
<div class="line">{</div>
<div class="line">  node.run();</div>
<div class="line">}</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md6"></a>
Adding behaviours</h2>
<p>However, this would not do anything useful - it needs to know what to do. So we should add some <code><a class="el" href="class_behaviour.html" title="Parent class for all other behaviours.">Behaviour</a></code>s. Each behaviour is one thing that the node knows how to do - set a number of LEDs to be active, move a servo to a certain angle, wiggle a servo for a bit etc.</p>
<p>Any number of behaviours can be added. They each need a unique name, so that they can be called correctly. Behaviours can also have parameters. In this example, we are adding three different behaviours, that all wiggle a servo. They have different speeds of wiggling, though (the last parameter) and different names. (<code>s1</code> is the Servo object they are working on).</p>
<div class="fragment"><div class="line">node.add( new ServoWiggle(s1, &quot;Wiggle&quot;) );</div>
<div class="line">node.add( new ServoWiggle(s1, &quot;Wiggle_Slow&quot;, 10) );</div>
<div class="line">node.add( new ServoWiggle(s1, &quot;Wiggle_Fast&quot;, 1) );</div>
</div><!-- fragment --><p>Now, the node will respond to three commands - <code>Wiggle</code>, <code>Wiggle_Slow</code> and <code>Wiggle_Fast</code>.</p>
<p>You can see a full example of this in the <code>ServoMotorNode</code> sketch.</p>
<h2><a class="anchor" id="autotoc_md7"></a>
Calling Behaviours</h2>
<p>Behaviours can currently be called in two ways:</p><ul>
<li>via Node RED, by sending a message on the channel. So, instead of sending '100' to make the node wiggle, now you have to send 'wiggle 100'.</li>
<li>you can also do this using the Arduino serial monitor, to make it easier to test</li>
</ul>
<p>Each <code><a class="el" href="class_behaviour.html" title="Parent class for all other behaviours.">Behaviour</a></code> has a unique name, and some number of parameters (mostly none, or one).</p>
<h1><a class="anchor" id="autotoc_md8"></a>
Behaviours</h1>
<p>Behaviours are defined as classes. Each class has a unique name, and a constructor that takes several arguments. These are for things that should not change, e.g. the Servo object that is being wiggled. When the behaviour is called, it is called with arguments for <em>just that action</em>. So, for wiggling a servo, the constructor is:</p>
<p><code><a class="el" href="class_servo_wiggle.html" title="Behaviour that wiggles a servo with the sweep angle specified as its argument.">ServoWiggle</a>( &lt;servo_object&gt;, &lt;name&gt;, &lt;wiggle_speed&gt; )</code></p>
<p>When the behaviour is then called, it is given the angle through which to wiggle, so the size of the wiggle can be controlled. So if the name is <code>Wiggle</code>, it would be called by sending:</p>
<p><code>Wiggle 40</code></p>
<p>The current set of behaviours and their parameters are:</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Constructor   </th><th class="markdownTableHeadNone">Called with   </th><th class="markdownTableHeadNone">Effect    </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone"><code><a class="el" href="class_servo_wiggle.html" title="Behaviour that wiggles a servo with the sweep angle specified as its argument.">ServoWiggle</a>( &lt;servo_object&gt;, &lt;name&gt;, &lt;wiggle_speed&gt; )</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt; &lt;int wiggle_angle&gt;</code>   </td><td class="markdownTableBodyNone">wiggles the servo    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone"><code><a class="el" href="class_servo_wiggle.html" title="Behaviour that wiggles a servo with the sweep angle specified as its argument.">ServoWiggle</a>( &lt;servo_object&gt;, &lt;name&gt;, &lt;wiggle_speed&gt; )</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt; &lt;int wiggle_angle&gt;</code>   </td><td class="markdownTableBodyNone">wiggles the servo    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone"><code>ServoGoto( &lt;servo_object&gt;, &lt;name&gt; )</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt; &lt;int angle&gt;</code>   </td><td class="markdownTableBodyNone">Moves the servo to that angle   </td></tr>
</table>
<p>The next ones that are about to be written are something like the following:</p>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Constructor   </th><th class="markdownTableHeadNone">Called with   </th><th class="markdownTableHeadNone">Effect    </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone"><code>LEDNumber( &lt;led_object&gt;, &lt;name&gt;, &lt;color&gt;)</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt; &lt;int num_leds&gt;</code>   </td><td class="markdownTableBodyNone">lights up that many LEDs on the object in the color given    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone"><code>LEDSet( &lt;led_object&gt;, &lt;name&gt; )</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt; &lt;int hue&gt; &lt;int brightness&gt;</code>   </td><td class="markdownTableBodyNone">Lights up the whole strip with the hue and brightness supplied    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone"><code>ContinuousServo( &lt;servo_object&gt;, &lt;name&gt;, &lt;speed&gt; )</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt; &lt;int time&gt;</code>   </td><td class="markdownTableBodyNone">Moves the continuous servo at the given speed for the given time. A negative time means move the other way.    </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone"><code>BallDrop( &lt;servo_object&gt;, &lt;name&gt;, &lt;speed&gt; )</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt;</code>   </td><td class="markdownTableBodyNone">Drops a single ball. The &lt;speed&gt; parameter or something similar tunes it to work with different mechanisms.    </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone"><code>LinearSlide( &lt;slide_object&gt;, &lt;name&gt; )</code>   </td><td class="markdownTableBodyNone"><code>&lt;name&gt; &lt;int position&gt;</code>   </td><td class="markdownTableBodyNone">Moves the linear slide to the given position. Position should be consistent for different slides, so maybe a value from 1.1000 mapped to the length of the slide.   </td></tr>
</table>
<p><em>Please update this table as you generate new behaviours!</em></p>
<h2><a class="anchor" id="autotoc_md9"></a>
Creating behaviours</h2>
<p>At first - make behaviours with your sketch, while you are testing them. See the examples for this!</p>
<p>When you've got something stable, add it to the library. If it fits within an existing file, add it to that (e.g. if it's another thing that Servos do, add it to <code><a class="el" href="_servo_behaviours_8h.html" title="Behaviours to control a servo motor. This should be extended with stable behaviours that are develope...">ServoBehaviours.h</a></code>). If it's a new kind of thing, then create a new file and add it in there. (Make sure you do the #IFNDEF stuff - ask if you don't know what that is!).</p>
<h2><a class="anchor" id="autotoc_md10"></a>
Some commands from the examples:</h2>
<p>Node Red commands for Evan's blocks:</p>
<p>Servos:</p><ul>
<li><code>Wiggle &lt;int&gt;</code> - int between 0 - 180</li>
<li><code>Slow_Wiggle &lt;int&gt;</code> - int between 0 - 180</li>
<li><code>Fast_Wiggle &lt;int&gt;</code> - int between 0 - 180</li>
<li><code>GoTo &lt;int&gt;</code> - int between 0 - 180</li>
<li><code>Drop</code> - behaviour that rotates from 0 to 180 and back again</li>
</ul>
<p>LEDs:</p><ul>
<li><code>LightSome_Green &lt;int&gt;</code> - turns LEDs green, int between 0 - 12</li>
<li><code>LightSome_Red &lt;int&gt;</code> - turns LEDs red, int between 0 - 12</li>
<li><code>LightSome &lt;int&gt;</code> - turns LEDs white, int between 0 - 12</li>
<li><code>LightAll_Green &lt;int&gt;</code> - turns all LEDs green with set brightness, int between 0 - 100 ?</li>
<li><code>LightAll_Red &lt;int&gt;</code> - turns all LEDs red with set brightness, int between 0 - 100 ?</li>
<li><code>Breathe &lt;int&gt;</code> - LEDs increase / decrease brightness with set speed, int between ?</li>
<li><code>Breathe_Blue &lt;int&gt;</code> - blue LEDs increase / decrease brightness with set speed, int between ? </li>
</ul>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
